/*
* File:   gtkmd5.cpp
* Author: arthur
*
* Created on 2010年4月15日, 下午1:51
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<gtk/gtk.h>
#include<ctype.h>

#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define H(x, y, z) ((x) ^ (y) ^ (z))
#define I(x, y, z) ((y) ^ ((x) | (~z)))

#define RL(x, y) (((x) << (y)) | ((x) >> (32 - (y))))  //x向左循环移y位

#define PP(x) (x<<24)|((x<<8)&0xff0000)|((x>>8)&0xff00)|(x>>24)  //将x高低位互换,例如PP(aabbccdd)=ddccbbaa

#define FF(a, b, c, d, x, s, ac) a = b + (RL((a + F(b,c,d) + x + ac),s))
#define GG(a, b, c, d, x, s, ac) a = b + (RL((a + G(b,c,d) + x + ac),s))
#define HH(a, b, c, d, x, s, ac) a = b + (RL((a + H(b,c,d) + x + ac),s))
#define II(a, b, c, d, x, s, ac) a = b + (RL((a + I(b,c,d) + x + ac),s))

unsigned A,B,C,D,a,b,c,d,i,len,flen[2],x[16];   //i临时变量,len文件长,flen[2]为64位二进制表示的文件初始长度
char filename[200];   //文件名
FILE *fp;

GtkWidget *resultentry;
GtkWidget *filew;
GtkWidget *entry;
gchar filepath[512];


void md5()
{                 //MD5核心算法,供64轮

        a=A,b=B,c=C,d=D;
        /**//* Round 1 */
        FF (a, b, c, d, x[ 0],  7, 0xd76aa478); /**//* 1 */
        FF (d, a, b, c, x[ 1], 12, 0xe8c7b756); /**//* 2 */
        FF (c, d, a, b, x[ 2], 17, 0x242070db); /**//* 3 */
        FF (b, c, d, a, x[ 3], 22, 0xc1bdceee); /**//* 4 */
        FF (a, b, c, d, x[ 4],  7, 0xf57c0faf); /**//* 5 */
        FF (d, a, b, c, x[ 5], 12, 0x4787c62a); /**//* 6 */
        FF (c, d, a, b, x[ 6], 17, 0xa8304613); /**//* 7 */
        FF (b, c, d, a, x[ 7], 22, 0xfd469501); /**//* 8 */
        FF (a, b, c, d, x[ 8],  7, 0x698098d8); /**//* 9 */
        FF (d, a, b, c, x[ 9], 12, 0x8b44f7af); /**//* 10 */
        FF (c, d, a, b, x[10], 17, 0xffff5bb1); /**//* 11 */
        FF (b, c, d, a, x[11], 22, 0x895cd7be); /**//* 12 */
        FF (a, b, c, d, x[12],  7, 0x6b901122); /**//* 13 */
        FF (d, a, b, c, x[13], 12, 0xfd987193); /**//* 14 */
        FF (c, d, a, b, x[14], 17, 0xa679438e); /**//* 15 */
        FF (b, c, d, a, x[15], 22, 0x49b40821); /**//* 16 */

       /**//* Round 2 */
        GG (a, b, c, d, x[ 1],  5, 0xf61e2562); /**//* 17 */
        GG (d, a, b, c, x[ 6],  9, 0xc040b340); /**//* 18 */
        GG (c, d, a, b, x[11], 14, 0x265e5a51); /**//* 19 */
        GG (b, c, d, a, x[ 0], 20, 0xe9b6c7aa); /**//* 20 */
        GG (a, b, c, d, x[ 5],  5, 0xd62f105d); /**//* 21 */
        GG (d, a, b, c, x[10],  9, 0x02441453); /**//* 22 */
        GG (c, d, a, b, x[15], 14, 0xd8a1e681); /**//* 23 */
        GG (b, c, d, a, x[ 4], 20, 0xe7d3fbc8); /**//* 24 */
        GG (a, b, c, d, x[ 9],  5, 0x21e1cde6); /**//* 25 */
        GG (d, a, b, c, x[14],  9, 0xc33707d6); /**//* 26 */
        GG (c, d, a, b, x[ 3], 14, 0xf4d50d87); /**//* 27 */
        GG (b, c, d, a, x[ 8], 20, 0x455a14ed); /**//* 28 */
        GG (a, b, c, d, x[13],  5, 0xa9e3e905); /**//* 29 */
        GG (d, a, b, c, x[ 2],  9, 0xfcefa3f8); /**//* 30 */
        GG (c, d, a, b, x[ 7], 14, 0x676f02d9); /**//* 31 */
        GG (b, c, d, a, x[12], 20, 0x8d2a4c8a); /**//* 32 */

        /**//* Round 3 */
        HH (a, b, c, d, x[ 5],  4, 0xfffa3942); /**//* 33 */
        HH (d, a, b, c, x[ 8], 11, 0x8771f681); /**//* 34 */
        HH (c, d, a, b, x[11], 16, 0x6d9d6122); /**//* 35 */
        HH (b, c, d, a, x[14], 23, 0xfde5380c); /**//* 36 */
        HH (a, b, c, d, x[ 1],  4, 0xa4beea44); /**//* 37 */
        HH (d, a, b, c, x[ 4], 11, 0x4bdecfa9); /**//* 38 */
        HH (c, d, a, b, x[ 7], 16, 0xf6bb4b60); /**//* 39 */
        HH (b, c, d, a, x[10], 23, 0xbebfbc70); /**//* 40 */
        HH (a, b, c, d, x[13],  4, 0x289b7ec6); /**//* 41 */
        HH (d, a, b, c, x[ 0], 11, 0xeaa127fa); /**//* 42 */
        HH (c, d, a, b, x[ 3], 16, 0xd4ef3085); /**//* 43 */
        HH (b, c, d, a, x[ 6], 23, 0x04881d05); /**//* 44 */
        HH (a, b, c, d, x[ 9],  4, 0xd9d4d039); /**//* 45 */
        HH (d, a, b, c, x[12], 11, 0xe6db99e5); /**//* 46 */
        HH (c, d, a, b, x[15], 16, 0x1fa27cf8); /**//* 47 */
        HH (b, c, d, a, x[ 2], 23, 0xc4ac5665); /**//* 48 */

        /**//* Round 4 */
        II (a, b, c, d, x[ 0],  6, 0xf4292244); /**//* 49 */
        II (d, a, b, c, x[ 7], 10, 0x432aff97); /**//* 50 */
        II (c, d, a, b, x[14], 15, 0xab9423a7); /**//* 51 */
        II (b, c, d, a, x[ 5], 21, 0xfc93a039); /**//* 52 */
        II (a, b, c, d, x[12],  6, 0x655b59c3); /**//* 53 */
        II (d, a, b, c, x[ 3], 10, 0x8f0ccc92); /**//* 54 */
        II (c, d, a, b, x[10], 15, 0xffeff47d); /**//* 55 */
        II (b, c, d, a, x[ 1], 21, 0x85845dd1); /**//* 56 */
        II (a, b, c, d, x[ 8],  6, 0x6fa87e4f); /**//* 57 */
        II (d, a, b, c, x[15], 10, 0xfe2ce6e0); /**//* 58 */
        II (c, d, a, b, x[ 6], 15, 0xa3014314); /**//* 59 */
        II (b, c, d, a, x[13], 21, 0x4e0811a1); /**//* 60 */
        II (a, b, c, d, x[ 4],  6, 0xf7537e82); /**//* 61 */
        II (d, a, b, c, x[11], 10, 0xbd3af235); /**//* 62 */
        II (c, d, a, b, x[ 2], 15, 0x2ad7d2bb); /**//* 63 */
        II (b, c, d, a, x[ 9], 21, 0xeb86d391); /**//* 64 */

        A += a;
        B += b;
        C += c;
        D += d;

}

void cb_okbutton(GtkWidget *widget, GtkWidget *entry)
{
        //得到输入控件entry值,传入filename
        const gchar *tmp;
        tmp = gtk_entry_get_text(GTK_ENTRY(entry));
        char filename[512];
        sprintf(filename, "%s", tmp);
        
        
        if (filename[0]==34) filename[strlen(filename)-1]=0,strcpy(filename,filename+1);  //支持文件拖曳,但会多出双引号,这里是处理多余的双引号
        if (!(fp=fopen(filename,"rb"))) {printf("Can not open this file!\n"); return;}  //以二进制打开文件
        fseek(fp, 0, SEEK_END);  //文件指针转到文件末尾
        if((len=ftell(fp))==-1) {printf("Sorry! Can not calculate files which larger than 2 GB!\n");fclose(fp); return ;}  //ftell函数返回long,最大为2GB,超出返回-1
        rewind(fp);  //文件指针复位到文件头
        A=0x67452301,B=0xefcdab89,C=0x98badcfe,D=0x10325476; //初始化链接变量
        flen[1]=len/0x20000000;     //flen单位是bit
        flen[0]=(len%0x20000000)*8;
        memset(x,0,64);   //初始化x数组为0
        fread(&x,4,16,fp);  //以4字节为一组,读取16组数据
        for(i=0;i<len/64;i++)
        {    //循环运算直至文件结束
          md5();
          memset(x,0,64);
          fread(&x,4,16,fp);
        }
        ((char*)x)[len%64]=128;  //文件结束补1,补0操作,128二进制即10000000
        if(len%64>55) md5(),memset(x,0,64);
        memcpy(x+14,flen,8);    //文件末尾加入原文件的bit长度
        md5();
        fclose(fp);
        
        // 将结果高低位逆反输出到buf
        char buf[512];
        sprintf(buf, "%08x%08x%08x%08x",PP(A),PP(B),PP(C),PP(D));  //高低位逆反输出
        
        //printf("%08x%08x%08x%08x\n",PP(A),PP(B),PP(C),PP(D));  //高低位逆反输出
        
        // printf("%s\n", buf);
        
        // 将buf内容显示在输入控件resultentry上
        gtk_entry_set_text(GTK_ENTRY(resultentry),buf);
        
        // 输入控件resultentry内容默认选定,方便用户复制
        gtk_editable_select_region(GTK_EDITABLE(resultentry), 0, GTK_ENTRY(resultentry)->text_length);
    
}

// 获得文件名,并将它打印到控制台(console)上
void file_ok_sel( GtkWidget *w, GtkFileSelection *fs )
{
        // 将文件选择控件所选择的文件路径传给filepath
        sprintf(filepath, "%s", gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
        
        //printf("%s\n", filepath);
        
        // 将文件选择控件所选择的文件路径显示在输入空间entry上
        gtk_entry_set_text (GTK_ENTRY (entry), filepath);
        
        //const gchar *tmp;
        //tmp = gtk_entry_get_text(GTK_ENTRY(entry));
        //printf("<<<<<<<<<< %s\n", tmp);
        
        // 文件已选择完毕,隐藏文件选择控件,貌似不能直接destroy掉..
        //gtk_widget_destroy(GTK_WIDGET(fs));
        gtk_widget_hide(GTK_WIDGET(fs));
}


void cb_button(GtkWidget *widget, GtkWidget *entry)
{
        
        // 创建一个新的文件选择构件 
        filew = gtk_file_selection_new ("File selection");
        
        g_signal_connect (G_OBJECT (filew), "destroy", G_CALLBACK (gtk_widget_destroy), NULL);
        // 为 ok_button 按钮设置回调函数,连接到 file_ok_sel function 函数 
        g_signal_connect (G_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", G_CALLBACK (file_ok_sel), filew);
        
        // 为 cancel_button 设置回调函数,销毁构件 
        g_signal_connect_swapped (G_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", G_CALLBACK (gtk_widget_destroy), filew);
        
        // 设置文件名,比如这个一个文件保存对话框,我们给了一个缺省文件名 
        gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), "hello.cmp");
        
        gtk_widget_show (filew);
    
}

int main(int argc, char *argv[])
{
        //声明组件变量
        GtkBuilder *builder;
        GtkWidget *window;
        GtkWidget *button;
        GtkWidget *okbutton;
        
        //每个gtk程序都需要的初始化
        gtk_init(&argc, &argv);
        
        //用来读取glade设计的界面
        builder = gtk_builder_new();
        
        //将gtkmd5.glade内容传给builder
        gtk_builder_add_from_file(builder, "gtkmd5.glade", NULL);
        
        //通过名字从gtkmd.glade中读取组件
        window = GTK_WIDGET(gtk_builder_get_object(builder, "window"));
        button = GTK_WIDGET(gtk_builder_get_object(builder, "button"));
        resultentry = GTK_WIDGET(gtk_builder_get_object(builder, "resultentry")); 
        entry = GTK_WIDGET(gtk_builder_get_object(builder, "entry"));
        okbutton = GTK_WIDGET(gtk_builder_get_object(builder, "okbutton"));
        
        //设置输入控件entry属性: 长度和默认值
        gtk_entry_set_max_length(GTK_ENTRY(entry), 512);
        gtk_entry_set_text(GTK_ENTRY(entry), "type in file path here");
        
        //设置输入控件resultentry属性: 长度,默认值和不可编辑
        gtk_entry_set_max_length(GTK_ENTRY(resultentry), 512);
        gtk_entry_set_text(GTK_ENTRY(resultentry), "here is the md5 info");
        gtk_editable_set_editable(GTK_EDITABLE(resultentry), FALSE);
        
        //将按键okbutton与回调函数cb_okbutton关联起来
        g_signal_connect(GTK_OBJECT(okbutton), "clicked", G_CALLBACK(cb_okbutton), entry);
        
        //将按键button与回调函数cb_button关联起来
        g_signal_connect(GTK_OBJECT(button), "clicked", G_CALLBACK(cb_button), entry);
        
        //自动把glade设计界面时选定的默认信号处理函数关联起来
        gtk_builder_connect_signals(builder, NULL);
        
        //释放builder空间
        g_object_unref(G_OBJECT(builder));
        
        //将组件window内的所有组件显示出来
        gtk_widget_show_all(window);
        
        //进入gtk主处理循环,程序等待X事件
        gtk_main();
        
        return 0;
}
